


const SCSESSIONSMGR 	= "@scenari.com/scSessionsMgr;1";


const nsCI              			= Components.interfaces;
const scISessionsMgr 	 			= nsCI.scISessionsMgr;
 
const cstStroragePref = "scenari.player.storage.path";

function ConfPlayer(){

	this._sessionsMgr = Components.classes[SCSESSIONSMGR].getService(scISessionsMgr);
	this.fPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	this.fPathChoice = document.getElementById('confStoragePath');
}


ConfPlayer.prototype.initView = function(){
	try {
		if(this.fPrefs.prefHasUserValue(cstStroragePref)){// la pref existe => path par defaut surcharge
			this.fPathChoice.selectedIndex = 1;
			this.setViewConf('pathActif');
		}else{
			this.fPathChoice.selectedIndex = 0;
			this.setViewConf('pathInactif');
		}
	}catch(e){
		ut.debug("ConfPlayer.prototype.refresh : "+e);
	}
}

ConfPlayer.prototype.setNewStoragePath = function(){
	try{
		this.setViewConf('pathActif');
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Veuillez slectionner un rpertoire", nsIFilePicker.modeGetFolder);
		if(this.fPrefs.prefHasUserValue(cstStroragePref)){
			var vFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			vFile.initWithPath(this.fPrefs.getCharPref(cstStroragePref));
			fp.displayDirectory = vFile;
			}
		var res = fp.show();
		if (res == nsIFilePicker.returnOK){
			document.getElementById('idStoragePath').setAttribute("value", fp.file.path);
		}
	}catch(e){
		ut.debug("WspMgr.prototype.getNewReposPath: "+e);
		return null;
	}
}


ConfPlayer.prototype.saveParameters = function(){
	try{
		var vKeyError = 0; 
		if(this.fPathChoice.selectedIndex == 1 && document.getElementById('idStoragePath').value!=""){
			var vFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			vFile.initWithPath(document.getElementById('idStoragePath').value);
			var vKeyError = this._sessionsMgr.canChangeStoragePath(vFile.path);
			if(vKeyError==0) vKeyError = this._sessionsMgr.changeStoragePath(vFile.path);
			if(vKeyError==0){
				if(!vFile.isWritable()) vKeyError 	= 8;
				if(!vFile.exists()) vKeyError 		= 16;
				if(!vFile.isDirectory()) vKeyError 	= 32;
			}
			if(vKeyError==0) this.fPrefs.setCharPref(cstStroragePref, document.getElementById('idStoragePath').value);
		}else{
			var vKeyError = this._sessionsMgr.canChangeStoragePath(null);
			if(vKeyError==0) vKeyError = this._sessionsMgr.changeStoragePath(null);
			if(vKeyError==0) if(this.fPrefs.prefHasUserValue(cstStroragePref)) this.fPrefs.clearUserPref(cstStroragePref);
		}

		if(vKeyError!=0){
			this.initView();
			var vMessageError = "";
			switch(vKeyError) {
				case Components.interfaces.scISessionsMgr.SC_ERR_NOT_ENOUGH_SPACE : vMessageError	= "Espace insuffisant.\nVeuillez choisir un nouvel emplacement."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_NO_WRITABLE : vMessageError		= "Droits insuffisants.\nVeuillez choisir un nouvel emplacement."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_FILE_OUT_UNEXIST : vMessageError	= "Rpertoire inexistant.\nVeuillez choisir un nouvel emplacement."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_FILE_OUT_NO_REPOSITORY : vMessageError	= "Veuillez choisir un rpertoire."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_SAME_REPOSITORY : vMessageError	= "Le rpertoire slectionn et le rpertoire actuel sont identiques.\nVeuillez choisir un autre rpertoire."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_FILE_OUT_NO_EMPTY : vMessageError	= "Le rpertoire slectionn n'est pas vide.\nVeuillez choisir un autre rpertoire."; break;
				case Components.interfaces.scISessionsMgr.SC_ERR_ALL_DATA_NO_CONSERVED : vMessageError	= "Le changement de rpertoire a t effectue correctement, mais des erreurs sont survenues lors de la copie des productions existentes.\nUne partie des productions a peut tre t perdue."; break;
				default : vMessageError		= "Veuillez choisir un nouvel emplacement."; break;
			}
			ut.alert(vMessageError);
		}
		return vKeyError;
	}catch(e){
		ut.debug("ConfPlayer.prototype.saveParameters : "+e);
	}
}


ConfPlayer.prototype.close = function(){
	var vSaveResult = this.saveParameters();
	if(vSaveResult=="0"){
		quit();
	}
}


ConfPlayer.prototype.setViewConf = function(pMode){
	if(pMode == 'pathActif'){
		document.getElementById('idStoragePath').disabled = false;

		if(this.fPrefs.prefHasUserValue(cstStroragePref) && this.fPrefs.getPrefType(cstStroragePref)==32) document.getElementById('idStoragePath').setAttribute("value", this.fPrefs.getCharPref(cstStroragePref));
		this.fPathChoice.selectedIndex = 1;
	}else{
		document.getElementById('idStoragePath').disabled = true;

		this.fPathChoice.selectedIndex = 0;
	}
}