


var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var HTMLNS = "http://www.w3.org/1999/xhtml";

var ut = {};



ut.alert = function(pText, pTitle, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	if(pCheckMsg) {
		var vRes = {};
		vRes.value = pChecked;
		vService.alertCheck(window, pTitle ? pTitle : "SCENARI - Message", pText, pCheckMsg, vRes);
		return vRes.value;
	} else {
		vService.alert(window, pTitle ? pTitle : "SCENARI - Message", pText);
		return false;
	}
}

ut.confirm = function(pText, pTitle, pLabelOk, pLabelCancel, pCheckMsg, pChecked){
	try{
		var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var vFlag = vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_0 + vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_1;
		
		return vService.confirmEx(	window, 
									pTitle ? pTitle : "SCENARI - Confirmation", 
									pText,
									vFlag,
									pLabelOk || "Ok",
									pLabelCancel || "Annuler",
									null,
									pCheckMsg, 
									pChecked || {}
								  ) == 0;
	}catch(e){ut.debug("ut.confirm failed::::"+e);}
	return true;
}

ut.prompt = function(pText, pTitle, pDefaultVal, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var vResCheck = {};
	vResCheck.value = pChecked;
	var vRes = {};
	vRes.value = pDefaultVal || "";
	var vBtnOk = vService.prompt(window, pTitle ? pTitle : "SCENARI", pText, vRes, pCheckMsg, vResCheck);
	return vBtnOk ? vRes.value : null;
}

ut.writeWait = function (pBox, pMessage){
	var vDoc = (pBox.nodeType==9) ? pBox : pBox.ownerDocument;
	if(pBox.localName.toLowerCase() == "html") {
		if(pBox.body) {
			pBox = pBox.body;
		} else {
			pBox = pBox.appendChild(vDoc.createElementNS("http://www.w3.org/1999/xhtml", "body"));
		}
	}
	while(pBox.hasChildNodes()) pBox.removeChild(pBox.lastChild);
	var vDesc = vDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
	vDesc.setAttribute("style", "font-style:italic; color:grey;");
	vDesc.appendChild(vDoc.createTextNode(pMessage || "Chargement en cours..."));
	pBox.appendChild(vDesc);
}


ut.openWindowWait = function (pType, pTitle, pMessage){
	return window.openDialog("chrome://scenariplayer/content/util/wait.xul", "", "chrome, centerscreen, dependent, resizable", pTitle, pMessage);
}
ut.closeWindowWait = function (pWin) {

	if(pWin) window.setTimeout(function(pWin){pWin.close();}, 10, pWin);
}


ut.loadExternalURL = function(pUrl){
  if (pUrl) {
    var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var vUri = vIoService.newURI(pUrl, null, null);
    var vExtProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
    vExtProtocolSvc.loadUrl(vUri);
  }
}



ut.getXml = function(pElement){
	return pElement ? new XMLSerializer().serializeToString(pElement) : "";
}

ut.parseXml = function (pString){
	try{
		var vParser = new DOMParser();
		var vDoc = vParser.parseFromString(pString, "text/xml");
		var vResult = vDoc.documentElement;
		if (vResult.tagName!="parserError" && vResult.namespaceURI!="http://www.mozilla.org/newlayout/xml/parsererror.xml"){
			return vResult;
		}else{
			return null;
		}
	}catch(e){
		this.debug("ut.parseXml:"+e);
		return null;
	}
}


ut.getDomFromLocalFileUrl = function (pUrl){
	try{
		var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var vChannel = vIoService.newChannel(pUrl,null,null);
		var vInput = vChannel.open();
		try {
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(vInput, vChannel.contentLength);
			var vParser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
			return vParser.parseFromStream(vBuf, null, vChannel.contentLength, "text/xml");
		} finally {
			vInput.close();
		}
	}catch(e){
		this.debug("Impossible de parser le fichier de l'URL : '"+pUrl+"': "+e);
		return null;
	}
}


ut.getDomFromHttpUrl = function(pUrl){
	try {
		var vReq = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		vReq.open("GET", pUrl, false, null, null);
		vReq.overrideMimeType("text/xml");
		vReq.send(null);
		return vReq.responseXML;
	} catch(e){
		this.debug("getDomFromHttpUrl. Echec au chargement de : "+pUrl+" : "+e);
		return null;
	}
}


ut.getSharedDom = function(pUrl){

	var vXml = document.implementation.createDocument("", "", null);
	vXml.async = false;
	vXml.load(pUrl);

	return vXml;
}



ut.execXsl = function(pXsl, pSrcNode, pDstNode){
	if(!pXsl) ut.debug("ut.execXsl : XSL null.");
	var vXsltProcessor = new XSLTProcessor();
	vXsltProcessor.importStylesheet(pXsl);
	var vFragment = vXsltProcessor.transformToFragment(pSrcNode, (pDstNode.nodeType==9) ? pDstNode : pDstNode.ownerDocument);

	while(pDstNode.hasChildNodes()) pDstNode.removeChild(pDstNode.lastChild);

	var vChild = vFragment.firstChild;
	while(vChild != null){

		var vNextChild = vChild.nextSibling;
		vFragment.removeChild(vChild); //A GARDER avant l'append sinon : constructor des XBL avant le remove et le parent est le fragment !
		pDstNode.appendChild(vChild);
		vChild = vNextChild;
	}

}


ut.selectSingleNode = function(pNodeXml, pXpath){
	if(pNodeXml==null) return null;
	var vDoc = pNodeXml.ownerDocument;
	if(vDoc==null) vDoc = pNodeXml;
	var vRes = vDoc.evaluate(pXpath, pNodeXml, vDoc.createNSResolver(vDoc.documentElement), XPathResult.FIRST_ORDERED_NODE_TYPE, null);
	return vRes.singleNodeValue;
}





ut.updateCommands = function(){
	try {
		for (var i =0; i < arguments.length; i++) {
			var vCmd = arguments[i];
			var vCtrl = top.document.commandDispatcher.getControllerForCommand(vCmd);

			var vEnabled = false;
			if (vCtrl) vEnabled = vCtrl.isCommandEnabled(vCmd);
			var vNode = document.getElementById(vCmd);
			if(vNode){
				if(vEnabled) vNode.removeAttribute("disabled");
				else vNode.setAttribute("disabled", "true");
			}
		}
	} catch (e) {
		ut.debug("ut.goUpdateCommand('"+pCmd+"') en erreur.\n"+e);
	}
}

ut.doCommand = function(pCmd){
  try {
    var vCtrl = top.document.commandDispatcher.getControllerForCommand(pCmd);
    if (vCtrl && vCtrl.isCommandEnabled(pCmd)) vCtrl.doCommand(pCmd);
  } catch (e) {
    ut.debug("ut.doCommand('"+pCmd+"') en erreur.\n"+e);
  }
}




ut.debug = function(pText) {
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	vConsoleService.logStringMessage(pText);//window.location.href+" : "+
}


ut.listProperties = function(pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}




ut.isClickContextMenu = function(pEvent){
	return ut.isMac ? pEvent.ctrlKey : pEvent.button == 2;
}


ut.isAccelPress = function(pEvent) {
	return ut.isMac ? pEvent.metaKey : pEvent.ctrlKey;
}



ut.fFsRightsDefault = 0755; 


ut.fFsRightsAll = 0777; 


ut.fFsRightsUserOnly = 0700; 



ut.isWin = navigator.platform.toLowerCase().indexOf("win") != -1;


ut.isMac = navigator.platform.toLowerCase().indexOf("mac") != -1;


ut.isUnix = navigator.platform.toLowerCase().indexOf("unix") != -1 || navigator.platform.toLowerCase().indexOf("linux") != -1 || navigator.platform.toLowerCase().indexOf("sun") != -1;


